<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24">
            <Form id="search-form" :label-width="70" v-show="searchOpen" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托商:">
                <Input v-model="formObj.client" @on-enter="_formSearch" placeholder="请输入委托单位" clearable></Input>
              </Form-item>
              <Form-item class="search-item" label="委托编号:">
                <Input v-model="formObj.entrustCode" @on-enter="_formSearch" placeholder="请输入委托编号" clearable></Input>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">
            <btn-list :msg="btn" :open="searchOpen" @on-result-change="_btnClick" :showSearchBtn="true"
                     class="contHide">
            </btn-list>
          </Col>
          <!-- 表格 -->
          <Col span="24">
            <PTVXETable
              ref="pageTable"
              :tableHeight="tableHeight"
              :getPage="getPage"
              :iconMsg="iconMsg"
              @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :width="item.width"
                :min-width="200"
                :fixed="item.fixed?item.fixed:undefined"
                sortable
              >
                <template slot-scope="scope">
                  <div v-if="item.detail"><a @click.stop="_detailModal(scope.row.id,scope.row.type)">{{scope.row[item.key]}}</a>
                  </div>
                  <span v-else-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else-if="item.status">{{scope.row[item.key].display}}</span>
                  <div v-else-if="item.type">{{scope.row[item.key] === 0 ? '企业':scope.row[item.key] ===
                    1?'政府':scope.row[item.key] === 2?'食品类抽样单': ''}}
                  </div>
                  <div v-else>{{scope.row[item.key]}}</div>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <!--组件加载-->
    <!--选择领样人-->
    <UserInfo ref="userModal" @on-result-change="_userResult"></UserInfo>
    <SampleManage ref="sampleManageModal" @on-result-change="_page"></SampleManage>
    <Operation ref="operation"></Operation>
    <FileManage ref="FileManage"></FileManage>
  </div>
</template>
<script>
import UserInfo from '../../../components/user-info-single/assignPerson'
import { soilEntrust } from '../../../api'
import Operation from '../../../components/operation/Operation'
import global from '../../../api/config'
import SampleManage from './TakeSampleManage'
export default {
  components: {
    UserInfo,
    SampleManage,
    Operation
  },
  data() {
    return {
      formObj: {
        client: undefined,
        entrustCode: undefined
      },
      typeList: [{ name: '企业', value: 0 }, { name: '政府', value: 1 }],
      iconMsg: [
        {
          type: 'ios-beaker',
          id: '',
          name: '管理样品'
        },
        { type: 'md-cloud', id: '', name: '附件' },
        {
          type: 'ios-clock',
          id: '',
          name: '操作日志'
        }
      ],
      getPage: {},
      pageColumns: [
        { title: '委托商', key: 'client', width: 200 },
        { title: '委托编号', key: 'entrustCode', width: 120 },
        { title: '委托日期', key: 'entrustDate', width: 120, date: true },
        { title: '钻孔位置', key: 'boreholeLocation', width: 120 },
        { title: '水深（米）', key: 'waterDepth', width: 120 },
        { title: '钻孔名称', key: 'boreholeName', width: 120 },
        { title: '进度', key: 'progress', width: 120, status: true },
        { title: '制表日期', key: 'tabulateDate', width: 120, date: true },
        { title: '制表人', key: 'tabulater', width: 120 },
        { title: '检验类别', key: 'testType', width: 120 }
      ],
      searchOpen: false,
      btn: [
        {
          type: 'primary',
          id: '',
          name: '导出取采样记录模板'
        },
        {
          type: 'primary',
          id: '',
          name: '导出留样登记表模板'
        },
        {
          type: 'primary',
          id: '',
          name: '导出样品标示卡模板'
        },
        {
          type: 'primary',
          id: '',
          name: '导出检测物品登记表模板'
        }
      ],
      selectIds: [],
      currentComponent: '',
      acceptSelectUserValue: ''
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('tabSearch')
      } else {
        return this.$tableHeight('tabNoSearch')
      }
    }
  },
  mounted() {
    // 样品接收是否选择人员
    // this.acceptSelectUserValue = localStorage.getItem('acceptSelectUserValue')
  },
  methods: {
    _userResult(data, msg) {
      const sendData = {
        ids: this.selectIds.join(',')
      }
      if (data) {
        sendData.person = data.realname
        sendData.personId = data.userId
      }
      switch (msg) {
        case 'sampleReceiveSendScanMan':
          // 扫码接收并发放
          this.$refs.refModal._open('扫码接收发放', data)
          break
      }
    },
    // 一键接收并发放

    // 组件返回值
    _componentResult(data, msg) {
      switch (this.currentComponent) {
        default:
          this._page()
      }
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(() => {
        switch (msg) {
          case '导出取采样记录模板':
            this._exportTemplateGet()
            break
          case '导出留样登记表模板':
            this._exportTemplateLiu()
            break
          case '导出样品标示卡模板':
            this._exportTemplateKa()
            break
          case '导出检测物品登记表模板':
            this._exportTemplateJian()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
          default:
            this._btnOption(msg)
        }
      })
    },
    _exportTemplateGet() {
      const data = {
        downloadUrl: '/soil/v1/excel/template_soil/QuYang.docx'
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定要导出该模板？',
        onOk: () => {
          this._download(data)
        }
      })
    },
    _exportTemplateLiu() {
      const data = {
        downloadUrl: '/soil/v1/excel/template_soil/LiuYangDengJI.docx'
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定要导出该模板？',
        onOk: () => {
          this._download(data)
        }
      })
    },
    _exportTemplateKa() {
      const data = {
        downloadUrl: '/soil/v1/excel/template_soil/YangPinBiaoShiKa.docx'
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定要导出该模板？',
        onOk: () => {
          this._download(data)
        }
      })
    },
    _exportTemplateJian() {
      const data = {
        downloadUrl: '/soil/v1/excel/template_soil/JinceWuPinDengJI.docx'
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定要导出该模板？',
        onOk: () => {
          this._download(data)
        }
      })
    },
    _download(data) {
      window.open(global.baseURL + data.downloadUrl, '_blank')
    },
    // btn操作
    _btnOption(msg) {
      console.log(msg)
      switch (msg) {
        case '一键接收':
          this._oneKeyReceive()
          break
        case '一键发放':
          this._oneKeySend()
          break
        case '一键接收并发放':
          this._oneKeyReceiveSend()
          break
        case '扫码接收':
          this.currentComponent = 'ReceiveScan'
          this.$nextTick(function() {
            this.$refs.refModal._open()
          })
          break
        case '扫码发放':
          this._scanSend('sampleSendScanMan')
          break
        case '扫码接收并发放':
          this._scanSend('sampleReceiveSendScanMan')
          break
      }
    },
    _iconClick(res, data, currentComponent) {
      this.currentComponent = currentComponent
      console.log(res)
      this.$nextTick(() => {
        switch (res) {
          case '管理样品':
            this._editModal(data.id, data.type, data.entrustCode)
            break
          case '项目管理':
            this.$refs.itemManageModal._open(data.id)
            break
          case '编辑协议':
            this._editModals(res, data)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._delete(data.id)
            break
          case '操作日志':
            this._operationRecord(data.id)
            break
        }
      })
    },
    _delete(id) {
      this.$Modal.confirm({
        title: '提示',
        content: '确定删除这条数据？',
        onOk: () => {
          this._deleteOk(id)
        }
      })
    },
    _deleteOk: async function(id) {
      const result = await soilEntrust.deleteById(id)
      if (result) {
        this._resultChange('删除成功')
      }
    },
    _editModal(id, type, name) {
      this.$refs.sampleManageModal._open(id, type, name)
    },
    _editModals(res, data) {
      if (res === '登记协议') {
        this.$refs.editModal._open(res, data)
      } else if (res === '编辑协议') {
        this.$store
          .dispatch('FoodContract/verificationEdit', { id: data.id })
          .then(() => {
            if (this.$store.state.FoodContract.model === true) {
              this.$refs.editModal._open(res, data)
            }
          })
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'selectIds':
          this.selectIds = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await soilEntrust.pageSampleTake(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _detailModal(id, type) {
      // 查看
      this.$store.dispatch('FoodContract/getById', id).then(() => {
        if (type === 0) {
          // 企业委托 ’0‘
          this.currentComponent = 'FoodContractCompanyDetail'
        } else {
          // 政府委托 ’1‘
          this.currentComponent = 'FoodContractGovernDetail'
        }
        this.$nextTick(() => {
          this.$refs.refModal._open(this.$store.state.FoodContract.model)
        })
      })
    },
    _search() {
      this._page()
    },
    _operationRecord(id) {
      // 操作日志
      this.$refs.operation._open(id)
    },
    _resultChange(msg) {
      if (this.$store.state.FoodContract.success) {
        this._page()
        this.$Message.success(msg)
        this.selectIds = []
      }
    },
    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'entrustId')
    }
  }
}
</script>
